#include <string.h>
#include <stdlib.h>
#include <vs1000.h>
#include <audio.h>
#include <mappertiny.h>
#include <minifat.h>
#include <physical.h>
#include <vsNand.h>
#include <player.h>

extern struct FsPhysical *ph;
extern u_int16 mallocAreaX[];     /* for ramboot */

extern struct FsMapper *map;
extern struct FsNandPhys fsNandPhys;

void main(void) {
    register int gotFile = 0;
    register u_int16 bsize;
    register u_int32 block = 0;
#if 1
    SetHookFunction((u_int16)IdleHook, UserInterfaceIdleHook);
    applAddr = NULL;
    currentKeyMap = sixKeyMap;
    ph = &fsNandPhys;
    //fsNandPhys.nandType = 0; /* 16MB small-page */
    fsNandPhys.waitns = 200;
#else
    ph = &fsNandPhys.p;
#endif
    if (InitFileSystem() == 0) {
	static const u_int32 bootFiles[] = {
	    FAT_MKID('I','M','G'), 0
	};
	minifatInfo.supportedSuffixes = bootFiles;
	if (OpenFile(0) < 0) {
	    memset(mallocAreaX, -1, 0x1000);
	    gotFile = ReadFile(mallocAreaX, 0, 2*0x1000) / 2;
	}
    }

    if (gotFile == 0) {
	/* No file found, error! */
	while (1) {
#if 1
	    register int i;
	    for (i=0;i<50;i++)
		BusyWait10();
#endif
#if 0
	    putch('n');
	    putch('\n');
#endif
	    USEX(GPIO1_ODATA) ^= 8|4;
	}
    }

    fsNandPhys.nandType = mallocAreaX[2]; //((struct FsNandPhys *)ph)->nandType = mallocAreaX[2];
    fsNandPhys.waitns = 200; //    ((struct FsNandPhys *)ph)->waitns   = 200;
    ph->eraseBlockSize = 1 << (mallocAreaX[3]>>8);
    ph->eraseBlocks = 1L << ((mallocAreaX[3] & 255) - (mallocAreaX[3]>>8));
    bsize = mallocAreaX[3];
    ph->Erase(ph, 0); /* Erase the first block */
    memset(minifatBuffer, -1, 256);
    ph->Write(ph, 0, (gotFile+255)/256, mallocAreaX, minifatBuffer);

    while (gotFile == 0x1000) {
	block += 0x2000/512;
	memset(mallocAreaX, -1, 0x1000);
	gotFile = ReadFile(mallocAreaX, 0, 2*0x1000) / 2;
	if ((bsize & 0xff00U) <= 0x0500) {
	    /* 16kB erase block size or less */
	    ph->Erase(ph, block);
	}
	memset(minifatBuffer, -1, 256);
	ph->Write(ph, block, (gotFile+255)/256, mallocAreaX, minifatBuffer);
    }

    /* mapper format is performed if needed */
#if 0
    ph->eraseBlocks--;
    map = FsMapFlCreate(ph, 1);
#endif
#if 0
    /* quick mapper init */
    //ph->eraseBlocks--; /*not needed*/
    {
	register int i;
	for (i=1;i<11;i++) {
	    ph->Erase(ph,(u_int32)i*ph->eraseBlockSize);
	}
	memset(mallocAreaX, 0xffff, 8);
	mallocAreaX[0] = 0x0000;
	mallocAreaX[1] = 0x0001; /*level 1 block*/
	mallocAreaX[4] = 0x0100; /*ph->eraseBlockSize*/
	mallocAreaX[5] = 0x0000;
	ph->Write(ph, ph->eraseBlockSize, 1, NULL, mallocAreaX); /*just spare*/
    }
#endif

#if 0
    /* Erase mapper datas from rest of the flash.. */
    {
	u_int32 block = ph->eraseBlockSize;
	register int i;
	for (i=1;i<ph->eraseBlocks;i++) {
	    ph->Read(ph, block, 1, NULL, mallocAreaX);
	    if ((mallocAreaX[2] & 0xff) != 0xff) {
		/* bad */
	    } else {
		ph->Erase(ph, block);
	    }
	    block += ph->eraseBlockSize;
	    if ((i & 31) == 0)
		USEX(GPIO1_ODATA) ^= 8;
	}
    }
#endif

    /* Programming done. */
#if 0
    while (1) {
	USEX(GPIO1_ODATA) ^= (8|4);
	BusyWait10();
    }
#else
    USEX(GPIO1_DDR) |= (8|4);
    for (bsize = 0; bsize < 20; bsize++) {
	register int i;
	USEX(GPIO1_ODATA) ^= (8|4);
	for (i=0;i<4*25;i++)
	    BusyWait10();
    }
    PowerOff();
//    PERIP(GPIO0_DDR) &= ~0x4000;
//    ((void (*)(void))(0x4000))();
#endif
}


